jjb: Add dev job for lttng-tools rootbuild on deb12-amd64
[lttng-ci.git] / scripts / lttng-modules / param-build.sh
CommitLineData
51c9c62d 1#!/bin/bash
f3d8604b 2#
51c9c62d 3# Copyright (C) 2016-2019 Michael Jeanson <mjeanson@efficios.com>
f3d8604b
MJ
4#
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 3 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see <http://www.gnu.org/licenses/>.
17
51c9c62d
MJ
18set -exu
19
39961776 20# Parameters
2456f978 21arch=${arch:-amd64}
39961776
MJ
22cross_arch=${cross_arch:-}
23ktag=${ktag:-}
5a196804
MJ
24kgitrepo=${kgitrepo:-}
25mversion=${mversion:-}
26mgitrepo=${mgitrepo:-}
39961776
MJ
27
28
339db64d
MJ
29## FUNCTIONS ##
30
f3d8604b
MJ
31# Kernel version compare functions
32verlte() {
51fa2ab3 33 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | head -n1)" ]
f3d8604b
MJ
34}
35
36verlt() {
28b10e79 37 # shellcheck disable=SC2015
51fa2ab3 38 [ "$1" = "$2" ] && return 1 || verlte "$1" "$2"
f3d8604b
MJ
39}
40
41vergte() {
51fa2ab3 42 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | tail -n1)" ]
f3d8604b
MJ
43}
44
45vergt() {
28b10e79 46 # shellcheck disable=SC2015
51fa2ab3 47 [ "$1" = "$2" ] && return 1 || vergte "$1" "$2"
f3d8604b
MJ
48}
49
339db64d 50
5a196804
MJ
51git_clone_modules_sources() {
52 mkdir -p "$MODULES_GIT_DIR"
28b10e79
MJ
53
54 # If the version starts with "refs/", checkout the specific git ref, otherwise treat it
55 # as a branch name.
56 if [ "${mversion:0:5}" = "refs/" ]; then
57 git clone --no-tags --depth=1 "${mgitrepo}" "$MODULES_GIT_DIR"
58 (cd "$MODULES_GIT_DIR" && git fetch origin "${mversion}" && git checkout FETCH_HEAD)
59 else
60 git clone --no-tags --depth=1 -b "${mversion}" "${mgitrepo}" "$MODULES_GIT_DIR"
61 fi
5a196804
MJ
62}
63
64# Checkout a shallow kernel tree of the specified tag
65git_clone_linux_sources() {
66 mkdir -p "$LINUX_GIT_DIR"
67 git clone --depth=1 -b "${ktag}" --reference "$LINUX_GIT_REF_REPO_DIR" "${kgitrepo}" "$LINUX_GIT_DIR"
68}
7e02032c 69
7e02032c 70
5a196804
MJ
71# Export the kernel sources from the git repo
72git_export_linux_sources() {
73 cd "$LINUX_GIT_DIR"
74 git archive "${ktag}" | tar -x -C "$LINUX_SRCOBJ_DIR"
75}
76
77
78# Upload the tar archive to the object store
79upload_archive_obj() {
80 s3cmd -c "$WORKSPACE/.s3cfg" put "$WORKSPACE/$obj_name" "$obj_url_prefix/"
81 rm -f "$WORKSPACE/$obj_name"
82}
83
84
85extract_archive_obj() {
86 tar -xf "$WORKSPACE/$obj_name" -C "$LINUX_OBJ_DIR"
87 rm -f "$WORKSPACE/$obj_name"
88}
89
90
91tar_archive_obj() {
92 cd "$LINUX_OBJ_DIR"
93 tar -cf "$WORKSPACE/$obj_name" -I pbzip2 .
94 cd -
95}
96
6c0b2710
KS
97list_gccs() {
98 local gccs
99 gccs=()
100 IFS=: read -r -a path_array <<< "$PATH"
101 while read -r gcc ; do
102 gccs+=("$gcc")
103 done < <(find "${path_array[@]}" -maxdepth 1 -regex '.*/gcc-[0-9\.]+$' -printf '%f\n' | sort -t- -k2 -V -r)
104 echo "${gccs[@]}"
105}
106
5a196804
MJ
107# Find the most recent GCC version supported by the kernel sources
108select_compiler() {
109 local selected_cc
110
111 cd "$LINUX_SRCOBJ_DIR"
112
113 kversion=$(make -s kernelversion)
114
115 set +e
116
6c0b2710 117 for cc in $(list_gccs) ; do
5a196804
MJ
118 if "${CROSS_COMPILE:-}${cc}" -I include/ -D__LINUX_COMPILER_H -D__LINUX_COMPILER_TYPES_H -E include/linux/compiler-gcc.h; then
119 selected_cc="$cc"
120 break
121 fi
122 done
123
124 set -e
125
126 if [ "x$selected_cc" = "x" ]; then
127 echo "Found no suitable compiler."
128 exit 1
129 fi
130
1d5a0a3c
MJ
131 # Force gcc-4.8 for kernels before 3.18
132 if { verlt "$kversion" "3.18"; }; then
23db2292 133 selected_cc=gcc-4.8
7e02032c
MJ
134 fi
135
425e4992
MJ
136 if [ "$selected_cc" != "gcc-4.8" ]; then
137 # Older kernel Makefiles do not expect the compiler to default to PIE
138 KAFLAGS="-fno-pie"
c45b04df 139 KCFLAGS="-fno-pie -no-pie -fno-stack-protector"
425e4992
MJ
140 KCPPFLAGS="-fno-pie"
141 export KAFLAGS KCFLAGS KCPPFLAGS
142 fi
143
5a196804 144 export CC="${CROSS_COMPILE:-}${selected_cc}"
1d5a0a3c 145 export HOSTCC="${selected_cc}"
5a196804
MJ
146
147 cd -
148}
149
150
151build_linux_kernel() {
152 cd "$LINUX_SRCOBJ_DIR"
153
154 kversion=$(make -s kernelversion)
155
7e02032c 156 # Generate kernel configuration
a1ae361e 157 case "$ktag" in
7e02032c 158 Ubuntu*)
39961776 159 if [ "${cross_arch}" = "powerpc" ]; then
5a196804 160 if vergte "${kversion}" "4.10"; then
39961776
MJ
161 echo "Ubuntu removed big endian powerpc configuration from kernel >= 4.10. Don't try to build it."
162 exit 0
163 fi
164 fi
af101606
MJ
165
166 # Disable riscv64 config generation, we don't have a toolchain on bionic
167 sed -i 's/riscv64 //' debian.master/etc/kernelconfig
168
0c1bde3d
KS
169 fakeroot debian/rules clean KW_DEFCONFIG_DIR=.
170
073dc82c 171 # Hack for kernel Ubuntu-hwe-5.8
0c1bde3d
KS
172 # The debian/control file is produced by the clean target above, so this
173 # check needs to happen afterwards.
174 if [ ! -f "debian/compat" ] && ! grep -q debhelper-compat debian/control; then
073dc82c
MJ
175 echo "10" > "debian/compat"
176 fi
177
0c1bde3d
KS
178 # genconfigs check can fail in certain cases, eg. when a more recent
179 # compiler exposes kernel configuration flags which aren't set in the
180 # Ubuntu annotations.
181 # In any case, the configuration will be updated with any missing values
182 # later in our build script.
183 fakeroot debian/rules genconfigs KW_DEFCONFIG_DIR=. do_skip_checks=true
5a196804 184 cp CONFIGS/"${ubuntu_config}" .config
7e02032c 185 ;;
c45b04df 186
7e02032c 187 *)
16844a6d
MJ
188 # Force 32bit build on i386, default is 64bit
189 if [ "$arch" = "i386" ]; then
5a196804
MJ
190 export ARCH="i386"
191 fi
192
193 # allyesconfig is mostly broken for kernels of the 2.6 series
194 if verlt "$kversion" "3.0"; then
195 vanilla_config="defconfig"
7a76a4d0
MJ
196 fi
197
5a196804 198 make "${vanilla_config}"
7e02032c
MJ
199 ;;
200 esac
201
53b51a15 202 # oldnoconfig was renamed in 4.19
5a196804 203 if vergte "$kversion" "4.19"; then
53b51a15 204 update_conf_target="olddefconfig"
5a196804 205 else
53b51a15 206 update_conf_target="oldnoconfig"
5a196804
MJ
207 fi
208
209 # Fix 'defined(@array)' was removed from recent perl
210 if [ -f "kernel/timeconst.pl" ]; then
211 sed -i 's/defined(\@\(.*\))/@\1/' kernel/timeconst.pl
212 fi
213
214 # Fix syntax of inline assembly which is confused with C++11 raw strings on gcc >= 5
53b51a15 215 if [ "$HOSTCC" != "gcc-4.8" ]; then
5a196804
MJ
216 if [ -f "arch/x86/kvm/svm.c" ]; then
217 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/svm.c
218 fi
219
220 if [ -f "arch/x86/kvm/vmx.c" ]; then
221 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/vmx.c
222 fi
223 fi
224
53b51a15
MJ
225 # Newer binutils don't accept 3 operand 'cmp' instructions on ppc64
226 # Convert them to 'cmpw' which was previously done silently
227 if verlt "$kversion" "4.9"; then
228 find arch/powerpc/ -name "*.S" -print0 | xargs -0 sed -i "s/\(cmp\)\(\s\+[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+\)/cmpw\2/"
229 find arch/powerpc/ -name "*.S" -print0 | xargs -0 sed -i "s/\(cmpli\)\(\s\+[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+\)/cmplwi\2/"
230 sed -i "s/\$pie \-o \"\$ofile\"/\$pie --no-dynamic-linker -o \"\$ofile\"/" arch/powerpc/boot/wrapper
231 fi
232
5a196804
MJ
233 # Fix a typo in v2.6.36.x
234 if [ -f "arch/x86/kernel/entry_64.S" ]; then
235 sed -i 's/END(do_hypervisor_callback)/END(xen_do_hypervisor_callback)/' arch/x86/kernel/entry_64.S
236 fi
237
53b51a15
MJ
238 # Fix compiler switch in vdso Makefile for 2.6.36 to 2.6.36.2
239 if { vergte "$kversion" "2.6.36" && verlte "$kversion" "2.6.36.3"; }; then
240 sed -i 's/-m elf_x86_64/-m64/' arch/x86/vdso/Makefile
241 sed -i 's/-m elf_i386/-m32/' arch/x86/vdso/Makefile
242 fi
243
5a196804
MJ
244 # Fix kernel < 3.0 with gcc >= 4.7
245 if verlt "$kversion" "3.0"; then
246 sed -i '/linux\/compiler.h/a #include <linux\/linkage.h> \/* For asmregparm *\/' arch/x86/include/asm/ptrace.h
247 sed -i 's/extern long syscall_trace_enter/extern asmregparm long syscall_trace_enter/' arch/x86/include/asm/ptrace.h
248 sed -i 's/extern void syscall_trace_leave/extern asmregparm void syscall_trace_leave/' arch/x86/include/asm/ptrace.h
249 echo "header-y += linkage.h" >> include/linux/Kbuild
250 fi
251
7e02032c 252 # GCC 4.8
53b51a15
MJ
253 if [ "$HOSTCC" == "gcc-4.8" ]; then
254 scripts/config --disable CONFIG_CC_STACKPROTECTOR_STRONG
255 fi
7e02032c
MJ
256
257 # Don't try to sign modules
53b51a15 258 scripts/config --disable CONFIG_MODULE_SIG
7e02032c 259
9ef18fa2 260 # Disable kernel stack frame correctness validation, introduced in 4.6.0 and currently fails
53b51a15 261 scripts/config --disable CONFIG_STACK_VALIDATION
5a196804
MJ
262
263 # Cause problems with inline assembly on i386
53b51a15 264 scripts/config --disable CONFIG_DEBUG_SECTION_MISMATCH
5a196804 265
1d5a0a3c 266 # Don't build samples, they are broken on some kernel releases
53b51a15
MJ
267 scripts/config --disable CONFIG_SAMPLES
268 scripts/config --disable CONFIG_BUILD_DOCSRC
c45b04df
MJ
269
270 # Disable kcov
53b51a15 271 scripts/config --disable CONFIG_KCOV
c45b04df
MJ
272
273 # Broken on some RT kernels
53b51a15 274 scripts/config --disable CONFIG_HYPERV
1d5a0a3c 275
1e300ea9 276 # Broken drivers
53b51a15
MJ
277 scripts/config --disable CONFIG_RAPIDIO_TSI721
278 scripts/config --disable CONFIG_SGI_XP
279 scripts/config --disable CONFIG_MFD_WM8994
280 scripts/config --disable CONFIG_DRM_RADEON
281 scripts/config --disable CONFIG_SND_SOC_WM5100
1e300ea9 282
5a196804
MJ
283 # IGBVF won't build with recent gcc on 2.6.38.x
284 if { vergte "$kversion" "2.6.37" && verlt "$kversion" "2.6.38"; }; then
53b51a15 285 scripts/config --disable CONFIG_IGBVF
5a196804 286 fi
9ef18fa2 287
c72041eb
MJ
288 # Don't fail the build on warnings
289 scripts/config --disable CONFIG_WERROR
290
51fa2ab3 291 # Set required options
53b51a15
MJ
292 scripts/config --enable CONFIG_TRACEPOINTS
293 scripts/config --enable CONFIG_KALLSYMS
294 scripts/config --enable CONFIG_HIGH_RES_TIMERS
295 scripts/config --enable CONFIG_KPROBES
296 scripts/config --enable CONFIG_FTRACE
297 scripts/config --enable CONFIG_BLK_DEV_IO_TRACE
298 scripts/config --enable CONFIG_KALLSYMS_ALL
299 scripts/config --enable CONFIG_HAVE_SYSCALL_TRACEPOINTS
300 scripts/config --enable CONFIG_PERF_EVENTS
301 scripts/config --enable CONFIG_EVENT_TRACING
302 scripts/config --enable CONFIG_KRETPROBES
7e02032c 303
1d28ffce
MJ
304 # FIXME: disable objtool on vmlinux, it OOMs on allyesconfig
305 sed -i 's/objtool_link vmlinux.o//' scripts/link-vmlinux.sh || true
81e61c58
MJ
306 # Starting with v6.1-rc6
307 sed -i 's/^objtool-enabled := .*/objtool-enabled := /' scripts/Makefile.vmlinux_o || true
1d28ffce 308
ba1a68bc
MJ
309 # Disable SORTTAB
310 sed -i 's/is_enabled CONFIG_BUILDTIME_TABLE_SORT/is_enabled CONFIG_NONEXISTANT/' scripts/link-vmlinux.sh || true
311
7a76a4d0 312 # Debug
5a196804
MJ
313 #cat .config
314
315 make "$update_conf_target" CC="$CC"
316 make -j"$NPROC" CC="$CC"
317
c45b04df 318 krelease=$(make -s kernelrelease CC="$CC")
5a196804
MJ
319
320 # Save the kernel and modules
321 mkdir -p "$LINUX_INSTOBJ_DIR/boot"
53b51a15 322 make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_MOD_STRIP=1 modules_install CC="$CC"
f4c112e8 323 make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_PATH="$LINUX_INSTOBJ_DIR/boot" install CC="$CC"
5a196804
MJ
324 rm -f "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source" "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/build"
325 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
326 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
327}
328
329
330extract_distro_headers() {
331
332 # Enter linux source dir
333 cd "${LINUX_SRCOBJ_DIR}"
334
335
336 # For RT kernels, copy version file
337 if [ -s localversion-rt ]; then
338 cp -a localversion-rt "${LINUX_HDROBJ_DIR}"
339 fi
340
341 # Copy all Makefile related stuff
342 find . -path './include/*' -prune \
343 -o -path './scripts/*' -prune -o -type f \
344 \( -name 'Makefile*' -o -name 'Kconfig*' -o -name 'Kbuild*' -o \
345 -name '*.sh' -o -name '*.pl' -o -name '*.lds' \) \
346 -print | cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
347
348 # Copy base scripts and include dirs
349 cp -a scripts include "${LINUX_HDROBJ_DIR}"
7e02032c 350
5a196804
MJ
351 # Copy arch includes
352 (find arch -name include -type d -print0 | \
353 xargs -0 -n1 -i: find : -type f) | \
354 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
355
356 # Copy arch scripts
357 (find arch -name scripts -type d -print0 | \
358 xargs -0 -n1 -i: find : -type f) | \
359 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
360
361 # Cleanup scripts
362 rm -f "${LINUX_HDROBJ_DIR}/scripts/*.o"
363 rm -f "${LINUX_HDROBJ_DIR}/scripts/*/*.o"
364
04873cc3 365 # On powerpc 32bits this object is required to link modules
5a196804 366 if [ "${karch}" = "powerpc" ]; then
10528202
MJ
367 if [ "x$(scripts/config -s CONFIG_PPC64)" = "xy" ] && vergte "${kversion}" "5.4"; then
368 :
369 else
04873cc3
MJ
370 cp -a --parents arch/powerpc/lib/crtsavres.[So] "${LINUX_HDROBJ_DIR}/"
371 fi
5a196804
MJ
372 fi
373
374 # On arm64 between 4.13 and 1.15 this object is required to build with ftrace support
375 if [ "${karch}" = "arm64" ]; then
376 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
377 cp -a --parents arch/arm64/kernel/ftrace-mod.[So] "${LINUX_HDROBJ_DIR}/"
378 fi
379 fi
380
381 # Newer kernels need objtool to build modules when CONFIG_STACK_VALIDATION=y
382 if [ -f tools/objtool/objtool ]; then
383 cp -a --parents tools/objtool/objtool "${LINUX_HDROBJ_DIR}/"
384 fi
385
386 if [ -f "arch/x86/kernel/macros.s" ]; then
387 cp -a --parents arch/x86/kernel/macros.s "${LINUX_HDROBJ_DIR}/"
388 fi
389
390 # Copy modules related stuff, if available
391 if [ -s Module.symvers ]; then
392 cp Module.symvers "${LINUX_HDROBJ_DIR}"
393 fi
394
395 if [ -s System.map ]; then
396 cp System.map "${LINUX_HDROBJ_DIR}"
397 fi
398
399 if [ -s Module.markers ]; then
400 cp Module.markers "${LINUX_HDROBJ_DIR}"
401 fi
402
403 # Copy config file
404 cp .config "${LINUX_HDROBJ_DIR}"
405
406 # Make sure the Makefile and version.h have a matching timestamp so that
407 # external modules can be built
408 if [ -s "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h" ]; then
409 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h"
410 elif [ -s "${LINUX_HDROBJ_DIR}/include/linux/version.h" ]; then
411 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/linux/version.h"
412 else
413 echo "Missing version.h"
414 exit 1
415 fi
416 touch -r "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/generated/autoconf.h"
417
418 # Copy .config to include/config/auto.conf so "make prepare" is unnecessary.
780f6285
MJ
419 if [ ! -f "${LINUX_HDROBJ_DIR}/include/config/auto.conf" ]; then
420 cp "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/config/auto.conf"
421 fi
5a196804
MJ
422
423 # Finally clean the object files from the full source tree
424 make clean
425
426 # And regen the modules support files
427 make modules_prepare CC="$CC"
51fa2ab3 428
04873cc3 429 # On powerpc 32bits this object is required to link modules
d815b018 430 if [ "${karch}" = "powerpc" ]; then
10528202
MJ
431 if [ "x$(scripts/config -s CONFIG_PPC64)" = "xy" ] && vergte "${kversion}" "5.4"; then
432 :
433 else
04873cc3
MJ
434 make arch/powerpc/lib/crtsavres.o CC="$CC"
435 fi
d815b018
MJ
436 fi
437
7a76a4d0 438 # On arm64 between 4.13 and 4.15 this object is required to build with ftrace support
a1ae361e 439 if [ "${karch}" = "arm64" ]; then
c236528e 440 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
5a196804 441 make arch/arm64/kernel/ftrace-mod.o CC="$CC"
a1ae361e
MJ
442 fi
443 fi
444
7e02032c 445 # Version specific tasks
a1ae361e 446 case "$ktag" in
7e02032c
MJ
447 Ubuntu*)
448 # Add Ubuntu ABI number to kernel headers, this is normally done by the packaging code
a1ae361e 449 ABINUM="$(echo "$ktag" | grep -P -o 'Ubuntu-(lts-)?.*-\K\d+(?=\..*)')"
5a196804
MJ
450 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> include/generated/utsrelease.h
451 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> "${LINUX_HDROBJ_DIR}/include/generated/utsrelease.h"
7e02032c
MJ
452 ;;
453 esac
7e02032c
MJ
454}
455
456
339db64d
MJ
457build_modules() {
458
5a196804
MJ
459 local kdir="$1"
460 local outdir="$2"
461 local kversion
462
463 kversion=$(make -C "$LINUX_HDROBJ_DIR" -s kernelversion)
339db64d 464
2456f978
MJ
465 # Try to catch some compatibility problems by turning some
466 # warnings into errors.
999a2aa0 467 #export KCFLAGS="$KCFLAGS -Wall -Werror"
2456f978 468
339db64d 469 # Enter lttng-modules source dir
5a196804 470 cd "${MODULES_GIT_DIR}"
339db64d
MJ
471
472 # kernels 3.10 to 3.10.13 and 3.11 to 3.11.2 introduce a deadlock in the
473 # timekeeping subsystem. We want those build to fail.
5a196804
MJ
474 if { vergte "$kversion" "3.10" && verlte "$kversion" "3.10.13"; } || \
475 { vergte "$kversion" "3.11" && verlte "$kversion" "3.11.2"; }; then
339db64d
MJ
476
477 set +e
478
479 # Build modules
51fa2ab3 480 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
0f71a764 481 ret=$?
339db64d 482
5a196804
MJ
483 set -e
484
339db64d 485 # We expect this build to fail, if it doesn't, fail the job.
0f71a764 486 if [ "$ret" -eq 0 ]; then
e9b44189 487 echo "This build should have failed."
339db64d
MJ
488 exit 1
489 fi
490
491 # We have to publish at least one file or the build will fail
5a196804 492 echo "This kernel is broken, there is a deadlock in the timekeeping subsystem." > "${outdir}/BROKEN.txt.ko"
339db64d 493
5a196804 494 KERNELDIR="${kdir}" make clean
7e02032c 495
339db64d
MJ
496 else # Regular build
497
498 # Build modules against full kernel sources
51fa2ab3 499 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
339db64d
MJ
500
501 # Install modules to build dir
5a196804 502 KERNELDIR="${kdir}" make INSTALL_MOD_PATH="${outdir}" modules_install
339db64d
MJ
503
504 # Clean build dir
5a196804 505 KERNELDIR="${kdir}" make clean
339db64d
MJ
506 fi
507}
508
509
510## MAIN ##
511
f3d8604b
MJ
512# Use all CPU cores
513NPROC=$(nproc)
514
5a196804
MJ
515MODULES_GIT_DIR="${WORKSPACE}/src/lttng-modules"
516LINUX_GIT_DIR="${WORKSPACE}/src/linux"
339db64d 517
5a196804
MJ
518LINUX_OBJ_DIR="${WORKSPACE}/linux"
519LINUX_SRCOBJ_DIR="${LINUX_OBJ_DIR}/sources"
520LINUX_HDROBJ_DIR="${LINUX_OBJ_DIR}/headers"
521LINUX_INSTOBJ_DIR="${LINUX_OBJ_DIR}/install"
339db64d 522
5a196804
MJ
523MODULES_OUTPUT_KSRC_DIR="${WORKSPACE}/build/lttng-modules-ksrc"
524MODULES_OUTPUT_KHDR_DIR="${WORKSPACE}/build/lttng-modules-khdr"
339db64d 525
5a196804
MJ
526LINUX_GIT_REF_REPO_DIR="$HOME/gitcache/linux-stable.git/"
527
528OBJ_STORE_URL="s3://jenkins"
529
530cd "$WORKSPACE"
531
532# Create build directories
533mkdir -p "${LINUX_SRCOBJ_DIR}" "${LINUX_HDROBJ_DIR}" "${LINUX_INSTOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
534
535git_clone_modules_sources
339db64d 536
7e02032c 537# Setup cross compile env if available
39961776 538if [ "x${cross_arch}" != "x" ]; then
7e02032c
MJ
539
540 case "$cross_arch" in
541 "armhf")
542 karch="arm"
543 cross_compile="arm-linux-gnueabihf-"
53b51a15 544 vanilla_config="imx_v6_v7_defconfig"
7e02032c
MJ
545 ubuntu_config="armhf-config.flavour.generic"
546 ;;
547
548 "arm64")
549 karch="arm64"
550 cross_compile="aarch64-linux-gnu-"
53b51a15 551 vanilla_config="defconfig"
7e02032c
MJ
552 ubuntu_config="arm64-config.flavour.generic"
553 ;;
554
555 "powerpc")
556 karch="powerpc"
557 cross_compile="powerpc-linux-gnu-"
e9b44189 558 vanilla_config="ppc44x_defconfig"
7e02032c
MJ
559 ubuntu_config="powerpc-config.flavour.powerpc-smp"
560 ;;
561
562 "ppc64el")
563 karch="powerpc"
564 cross_compile="powerpc64le-linux-gnu-"
e9b44189 565 vanilla_config="pseries_le_defconfig"
7e02032c
MJ
566 ubuntu_config="ppc64el-config.flavour.generic"
567 ;;
568
569 *)
51fa2ab3 570 echo "Unsupported cross arch $cross_arch"
7e02032c
MJ
571 exit 1
572 ;;
573 esac
339db64d 574
7e02032c
MJ
575 # Export variables used by Kbuild for cross compilation
576 export ARCH="${karch}"
577 export CROSS_COMPILE="${cross_compile}"
339db64d 578
7e02032c 579# Set arch specific values if we are not cross compiling
39961776 580elif [ "x${arch}" != "x" ]; then
e9b44189 581
7e02032c 582 case "$arch" in
16844a6d 583 "i386")
7e02032c 584 karch="x86"
e9b44189 585 vanilla_config="allyesconfig"
7e02032c
MJ
586 ubuntu_config="i386-config.flavour.generic"
587 ;;
588
16844a6d 589 "amd64")
7e02032c 590 karch="x86"
e9b44189 591 vanilla_config="allyesconfig"
7e02032c
MJ
592 ubuntu_config="amd64-config.flavour.generic"
593 ;;
594
595 "armhf")
596 karch="arm"
e9b44189 597 vanilla_config="allyesconfig"
7e02032c
MJ
598 ubuntu_config="armhf-config.flavour.generic"
599 ;;
600
601 "arm64")
602 karch="arm64"
e9b44189 603 vanilla_config="allyesconfig"
7e02032c
MJ
604 ubuntu_config="arm64-config.flavour.generic"
605 ;;
606
607 "powerpc")
608 karch="powerpc"
e9b44189 609 vanilla_config="allyesconfig"
7e02032c
MJ
610 ubuntu_config="powerpc-config.flavour.powerpc-smp"
611 ;;
612
613 "ppc64el")
614 karch="powerpc"
e9b44189 615 vanilla_config="allyesconfig"
7e02032c
MJ
616 ubuntu_config="ppc64el-config.flavour.generic"
617 ;;
618
619 *)
620 echo "Unsupported arch $arch"
621 exit 1
622 ;;
623 esac
624else
04873cc3 625 echo "No arch or cross_arch specified"
7e02032c
MJ
626 exit 1
627fi
339db64d 628
339db64d 629
b214d997 630
5a196804
MJ
631# First get the kernel build from the object store, or build it, if it's
632# not available.
339db64d 633
5a196804
MJ
634echo "# Setup endpoint
635host_base = obj.internal.efficios.com
636host_bucket = obj.internal.efficios.com
637bucket_location = us-east-1
638use_https = True
7e02032c 639
5a196804
MJ
640# Setup access keys
641access_key = jenkins
642secret_key = echo123456
339db64d 643
5a196804
MJ
644# Enable S3 v4 signature APIs
645signature_v2 = False" > "$WORKSPACE/.s3cfg"
339db64d 646
c45b04df 647url_hash="$(echo -n "$kgitrepo" | md5sum | awk '{ print $1 }')"
5a196804 648obj_name="linux.tar.bz2"
87445931
MJ
649
650if [ "x${cross_arch}" = "x" ]; then
651 obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash/$ktag/$arch/native"
652else
653 obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash/$ktag/${cross_arch}"
654fi
655
5a196804 656obj_url="$obj_url_prefix/$obj_name"
339db64d 657
5a196804 658set +e
e18b6e95
KS
659# In s3cmd 2.3, the return code of get when an object does not exist (64)
660# is different than in 2.2 (12). The return codes of 's3cmd info' are
661# consistent between 2.2 and 2.3.
662s3cmd -c "$WORKSPACE/.s3cfg" info "$obj_url"
5a196804
MJ
663ret=$?
664set -e
339db64d 665
5a196804
MJ
666case "$ret" in
667 "0")
e18b6e95 668 s3cmd -c "$WORKSPACE/.s3cfg" get "$obj_url"
5a196804
MJ
669 extract_archive_obj
670 ;;
a1ae361e 671
5a196804
MJ
672 "12")
673 echo "File not found"
339db64d 674
5a196804
MJ
675 # Build all the things and upload
676 # then finish the module build...
339db64d 677
5a196804
MJ
678 git_clone_linux_sources
679 git_export_linux_sources
339db64d 680
5a196804 681 select_compiler
a1ae361e 682
5a196804
MJ
683 ## PREPARE FULL LINUX SOURCE TREE
684 build_linux_kernel
d138fc44 685
5a196804
MJ
686 ## EXTRACT DISTRO STYLE KERNEL HEADERS / DEVEL
687 extract_distro_headers
339db64d 688
5a196804 689 tar_archive_obj
339db64d 690
5a196804 691 upload_archive_obj
339db64d 692
5a196804 693 ;;
339db64d 694
5a196804
MJ
695 *)
696 echo "Unknown error? Abort"
697 exit 1
698 ;;
699esac
339db64d 700
5a196804 701select_compiler
f3d8604b 702
7e02032c 703## BUILD modules
5a196804
MJ
704# Either we downloaded a pre-build kernel or we built it and uploaded
705# the archive for future builds.
706
707cd "$WORKSPACE"
f3d8604b 708
339db64d 709# Build modules against full kernel sources
5a196804 710build_modules "${LINUX_SRCOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}"
f3d8604b 711
339db64d 712# Build modules against kernel headers
5a196804 713build_modules "${LINUX_HDROBJ_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
f3d8604b 714
5a196804
MJ
715# Make sure some modules were actually built
716tree "${MODULES_OUTPUT_KSRC_DIR}"
717if [ "x$(find "${MODULES_OUTPUT_KSRC_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
7e02032c
MJ
718 echo "No modules built!"
719 exit 1
720fi
721
5a196804
MJ
722tree "${MODULES_OUTPUT_KHDR_DIR}"
723if [ "x$(find "${MODULES_OUTPUT_KHDR_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
7e02032c
MJ
724 echo "No modules built!"
725 exit 1
726fi
b214d997 727
f3d8604b 728# EOF
This page took 0.081203 seconds and 4 git commands to generate.